﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace WindowsFormsApp2
{
    /// <summary>
    /// Klasse mit Extension-Methoden
    /// </summary>
    static class MyExtensions
	{
		/// <summary>
		/// Überladung zum Testen, ob this Object
		/// von der Klasse cls abgeleitet ist
		/// </summary>
		/// <param name="ob">das Object</param>
		/// <param name="cls">die Klasse</param>
		/// <returns></returns>
		public static bool TestClass(this object ob, Type cls)
		{
			// Basisklassen abfragen
			return ob.GetType().IsSubclassOf(cls);
		}

		/// <summary>
		/// Überladung zum Testen, ob this Object
		/// das Interface interf implementiert
		/// </summary>
		/// <param name="ob">das Object</param>
		/// <param name="interf">das Interface</param>
		/// <returns></returns>
		public static bool TestInterface(this object ob, Type interf)
		{
			// Interfaces abfragen
			Type obType = ob.GetType();
			List<Type> inter = obType.GetInterfaces().ToList();
			return inter.Contains(interf);
		}
	}
}
